<script src="@#file#(math.min.js)" type="text/javascript"></script>
<script src="@#file#(bezier.js)"   type="text/javascript"></script>

<p>Interpolacijska Bezierova krivulja je Bezierova krivulja koja prolazi kroz sve zadane točke. Izdvojit ćemo dva načina njezine konstrukcije.</p>

<p>Pretpostavimo da imamo zadanih \(n+1\) točku kroz koje krivulja mora proći. Te točke označit ćemo \(\vec p_0\), \(\vec p_1\), \(\ldots\), \(\vec p_n\); tretirat ćemo ih kao vektor-retke.</p>

<p>Želimo pronaći aproksimacijsku Bezierovu krivulju stupnja \(n\) za koju vrijedi da je \(\vec p(0) = \vec p_0\), \(\vec p(1/n) = \vec p_1\), \(\vec p(2/n) = \vec p_2\), \( \ldots \), \(\vec p((n-1)/n) = \vec p_{n-1}\), \(\vec p(1) = \vec p_n\). Ponovimo još jednom: želimo pronaći aproksimacijsku Bezierovu krivulju koja za vrijednost parametra \(i/n\) prolazi kroz zadanu točku \(\vec p_i\). Uočite da takva krivulja ima dva svojstva:
</p>
<ol>
<li>Ona je interpolacijska s obzirom na zadane točke \(\vec p_0\), \(\vec p_1\), \(\ldots\), \(\vec p_n\) jer prolazi kroz sve njih.</li>
<li>Točke \(\vec p_0\), \(\vec p_1\), \(\ldots\), \(\vec p_n\) <em>nisu</em> točke njezinog kontrolnog poligona! Samo će početna i konačna točka biti dio njezinog kontrolnog poligona.</li>
</ol>

<p>Naš zadatak je stoga <em>pronaći vrhove kontrolnog poligona</em> koji će definirati aproksimacijsku Bezierovu krivulju koja za zadane vrijednosti parametara prolazi kroz zadane točke. Ovo je ilustrirano na sljedećem prikazu gdje su zadane tri točke.</p>

<p>Uključite najprije prikaz aproksimacijske Bezierove krivulje i uvjerite se da ona ne prolazi kroz sve tri zadane točke: prolazi samo kroz prvu i zadnju. Isključite prikaz ove krivulje.</p>

<p>Potom uključite prikaz interpolacijske Bezierove krivulje i uvjerite se da ona prolazi kroz sve tri zadane točke. Želimo pronaći nove vrhove koji će definirati neki drugi kontrolni poligon čija će se aproksimacijska Bezierova krivulja podudariti s našom željenom interpolacijskom krivuljom. Uključite prikaz ovog poligona. Mišem možete pomicati zadane točke.</p>

  <div style="width: 800px; height: 300px; position:relative;">
  <canvas id="myCanvas1" width="800" height="300" style="border: 1px solid black;"></canvas>
  </div>
  <script type="text/javascript">
    var bez1 = new drawInterpolationBezier("myCanvas1");
    bez1.addingEnabled = false;
    bez1.buildProc = false;
    bez1.setAllPoints([[43,258],[206,135],[699,238]]);
    bez1.paint();
  </script>
  <input type="checkbox" onclick="bez1.curveApprox=this.checked; bez1.paint();"> Aproksimacijska krivulja<br>
  <input type="checkbox" onclick="bez1.controlPolygon=this.checked; bez1.paint();"> Prikaži kontrolni poligon aproksimacijske krivulje<br>
  <input type="checkbox" onclick="bez1.curveInterpol=this.checked; bez1.paint();"> Interpolacijska krivulja<br>
  <input type="checkbox" onclick="bez1.intControlPolygon=this.checked; bez1.paint();"> Prikaži kontrolni poligon za interpolacijsku krivulju<br>

<p>Evo što znamo. Točka aproksimacijske Bezierove krivulje koja se dobiva za neku vrijednost parametra \(t\) određena je izrazom:
\[
  \vec p(t) = \mathcal{T}(t) \cdot \textbf{B}_n \cdot \textbf{R}
\]
gdje je \(\mathcal{T}(t)\) vektor-redak potencija parametra \(t\). Znamo da za vrijednosti parametra \(i/n\) to mora dati zadanu točku \(\vec p_i\). Stoga možemo pisati:
\[
\begin{align*}
 \vec p(0) &amp;= \mathcal{T}(0) \cdot \textbf{B}_n \cdot \textbf{R} = \vec p_0 \\
 \vec p(1/n) &amp;= \mathcal{T}(1/n) \cdot \textbf{B}_n \cdot \textbf{R} = \vec p_1 \\
 \vec p(2/n) &amp;= \mathcal{T}(2/n) \cdot \textbf{B}_n \cdot \textbf{R} = \vec p_2 \\
 \ldots &amp;= \ldots; \\
 \vec p((n-1)/n) &amp;= \mathcal{T}((n-1)/n) \cdot \textbf{B}_n \cdot \textbf{R} = \vec p_{n-1} \\
 \vec p(1) &amp;= \mathcal{T}(1) \cdot \textbf{B}_n \cdot \textbf{R} = \vec p_n
\end{align*}
\]
U danim izrazima znamo sve osim matrice \(\textbf{R}\) koja je upravo matrica vrhova kontrolnog poligona. Imamo \(n+1\) jednadžbu i tražimo matricu \(\textbf{R}\) koja ima \(n+1\) redak. Sve ove jednadžbe možemo kompaktnije zapisati kao jednu jednadžbu:
\[
\left[ \begin{array}{c}  \mathcal{T}(0) \\ \mathcal{T}(1/n) \\ \mathcal{T}(2/n) \\ ... \\ \mathcal{T}((n-1)/n) \\ \mathcal{T}(1)\end{array} \right] \cdot \textbf{B}_n \cdot \textbf{R} = \left[ \begin{array}{c} \vec p_0 \\ \vec p_1 \\ \vec p_2 \\ ... \\ \vec p_{n-1} \\ \vec p_n \end{array} \right]
\]
Matricu s lijeve strane raspisanu po retcima kraće ćemo označiti s \(\textbf{T}\): to je kvadratna matrica dimenzija \((n+1) \times (n+1)\). Matricu zadanih točaka s desne strane označit ćemo s \(\textbf{P}\). Uz ove oznake, čitav sustav jednadžbi može se zapisati kao:
\[
 \textbf{T} \cdot \textbf{B}_n \cdot \textbf{R} = \textbf{P}
\]
Pomnožimo li čitavu sustav s lijeve strane inverzom umnoška \(\textbf{T} \cdot \textbf{B}_n\) dobivamo rješenje za vrhove kontrolnog poligona:
\[
 \textbf{R} = (\textbf{T} \cdot \textbf{B}_n)^{-1} \cdot \textbf{P}
\]
</p>

<p>Pogledajmo jedan primjer. Zadane su tri točke: \(\vec p_0 = \left[ \begin{array}{cc} 1 &amp; 2 \end{array} \right]\), \(\vec p_1 = \left[ \begin{array}{cc} 5 &amp; 8 \end{array} \right]\) i \(\vec p_2 = \left[ \begin{array}{cc} 6 &amp; -1 \end{array} \right]\). Potrebno je odrediti interpolacijsku Bezierovu krivulju (dakle, krivulju koja prolazi kroz te točke). Kako imamo tri točke, krivulja će biti kvadratna (drugog stupnja; \(n=2\)). Tražit ćemo da ona za \(t=0\) prolazi kroz \(\vec p_0\), da za \(t=0.5\) prolazi kroz \(\vec p_1\) i da za \(t=1\) prolazi kroz \(\vec p_2\). U tom slučaju, matrica \(\mathcal{T}\) će glasiti:
\[
\textbf{T} = \left[ \begin{array}{c} 
  \mathcal{T}(0) \\ 
  \mathcal{T}(0.5) \\ 
  \mathcal{T}(1) \\ 
\end{array} \right] = \left[ \begin{array}{ccc} 
  0^2 &amp; 0^1 &amp; 1 \\ 
  0.5^2 &amp; 0.5^1 &amp; 1 \\ 
  1^2 &amp; 1^1 &amp; 1 \\ 
\end{array} \right] = \left[ \begin{array}{ccc} 
  0 &amp; 0 &amp; 1 \\ 
  0.25 &amp; 0.5 &amp; 1 \\ 
  1 &amp; 1 &amp; 1 \\ 
\end{array} \right]
\]
Također, matricu \(\textbf{B}_2\) odredili smo prije, i ona je:
\[
 \textbf{B}_2 = \left[ \begin{array}{cccc} 1 &amp; -2 &amp; 1 \\ -2 &amp; 2 &amp; 0 \\ 1 &amp; 0 &amp; 0 \end{array} \right]
\]
Umnožak \(\textbf{T} \cdot \textbf{B}_2\) tada je:
\[
  \textbf{T} \cdot \textbf{B}_2 = \left[ \begin{array}{ccc} 
  1 &amp; 0 &amp; 0 \\ 
  0.25 &amp; 0.5 &amp; 0.25 \\ 
  0 &amp; 0 &amp; 1 \\ 
\end{array} \right]
\]
a njegov inverz:
\[
  (\textbf{T} \cdot \textbf{B}_2)^{-1} = \left[ \begin{array}{ccc} 
  1 &amp; 0 &amp; 0 \\ 
  -0.5 &amp; 2 &amp; -0.5 \\ 
  0 &amp; 0 &amp; 1 \\ 
\end{array} \right]
\]
Da bismo dobili točke kontrolnog poligona, moramo izračunati umnožak ovog inverza i matrice zadanih točaka \((\textbf{T} \cdot \textbf{B}_n)^{-1} \cdot \textbf{P}\). Imamo:
\[
 \textbf{R} = \left[ \begin{array}{ccc} 
  1 &amp; 0 &amp; 0 \\ 
  -0.5 &amp; 2 &amp; -0.5 \\ 
  0 &amp; 0 &amp; 1 \\ 
\end{array} \right] \cdot \left[ \begin{array}{ccc} 
  1 &amp; 2 \\ 
  5 &amp; 8 \\ 
  6 &amp; -1 \\ 
\end{array} \right] = \left[ \begin{array}{ccc} 
  1 &amp; 2 \\ 
  6.5 &amp; 15.5 \\ 
  6 &amp; -1 \\ 
\end{array} \right]
\]
Tražena interpolacijska krivulja tada je zadana izrazom:
\[
  \vec p(t) = \mathcal{T}(t) \cdot \textbf{B}_2 \cdot \textbf{R}
\]
gdje je \(\textbf{R}\) matrica vrhova kontrolnih poligona koje smo upravo odredili, pa imamo:
\[
  \vec p(t) = \mathcal{T}(t) \cdot \left[ \begin{array}{cccc} 1 &amp; -2 &amp; 1 \\ -2 &amp; 2 &amp; 0 \\ 1 &amp; 0 &amp; 0 \end{array} \right] \cdot \left[ \begin{array}{ccc} 
  1 &amp; 2 \\ 
  6.5 &amp; 15.5 \\ 
  6 &amp; -1 \\ 
\end{array} \right] = \mathcal{T}(t) \cdot \left[ \begin{array}{ccc} 
  -6 &amp; -30 \\ 
  11 &amp; 27 \\ 
  1 &amp; 2 \\ 
\end{array} \right]
\]
Uzmemo li sada da je \(t=0\), \(\mathcal{T}(0) = \left[ \begin{array}{ccc} 0 &amp; 0 &amp; 1 \end{array} \right]\), pa umnožak izolira posljednji redak matrice, odnosno za \(\vec p(0)\) dobivamo \(\left[ \begin{array}{cc} 1 &amp; 2 \end{array} \right]\) što je upravo zadana točka \(\vec p_0\).
Ako je \(t=0.5\), \(\mathcal{T}(0.5) = \left[ \begin{array}{ccc} 0.25 &amp; 0.5 &amp; 1 \end{array} \right]\), pa za \(\vec p(0.5)\) dobivamo \(\left[ \begin{array}{cc} 5 &amp; 8 \end{array} \right]\) što je zadana točka \(\vec p_1\).
Ako je \(t=1\), \(\mathcal{T}(1) = \left[ \begin{array}{ccc} 1 &amp; 1 &amp; 1 \end{array} \right]\), pa za \(\vec p(1)\) dobivamo \(\left[ \begin{array}{cc} 6 &amp; -1 \end{array} \right]\) što je zadana točka \(\vec p_2\).
</p>

<p>Koji je drugi način za pronalazak interpolacijske Bezierove krivulje? Primijetite da smo u prethodnom riješenom primjeru došli do izraza oblika:
\[
  \vec p(t) = \mathcal{T}(t) \cdot \textbf{K}
\]
gdje je matrica \(\textbf{K}\) rezultat množenja matrice \(\textbf{B}_2\) i pronađenih vrhova novog kontrolnog poligona. Tu matricu možemo tražiti i izravno. Naime, krenimo od ovog oblika i tražimo da krivulja za \(t=i/n\) prođe upravo kroz \(\vec p_i\). Opet stvaramo sustav od \((n+1)\) jednadžbe:
\[
\begin{align*}
  \vec p(0) &amp;= \mathcal{T}(0) \cdot \textbf{K} = \vec p_0 \\
  \vec p(1/n) &amp;= \mathcal{T}(1/n) \cdot \textbf{K} = \vec p_1 \\
  \ldots &amp;= \ldots \\
  \vec p(1) &amp;= \mathcal{T}(1) \cdot \textbf{K} = \vec p_n \\
\end{align*}
\]
što nas ponovno vodi na sustav:
\[
\left[ \begin{array}{c}  \mathcal{T}(0) \\ \mathcal{T}(1/n) \\ \mathcal{T}(2/n) \\ ... \\ \mathcal{T}((n-1)/n) \\ \mathcal{T}(1)\end{array} \right] \cdot \textbf{K} = \left[ \begin{array}{c} \vec p_0 \\ \vec p_1 \\ \vec p_2 \\ ... \\ \vec p_{n-1} \\ \vec p_n \end{array} \right]
\]
odnosno:
\[
 \textbf{T} \cdot \textbf{K} = \textbf{P}
\]
što množenjem inverzom od \(\textbf{T}\) s lijeve strane izravno daje:
\[
 \textbf{K} = (\textbf{T})^{-1} \cdot \textbf{P}
\]
Nakon što smo odredili \(\textbf{K}\), točke interpolacijske krivulje računamo izravno:
\[
  \vec p(t) = \mathcal{T}(t) \cdot \textbf{K}
\]
</p>

<p>Provjerimo da ćemo uz iste početne točke dobiti jednak rezultat. Zadane točke su bile: \(\vec p_0 = \left[ \begin{array}{cc} 1 &amp; 2 \end{array} \right]\), \(\vec p_1 = \left[ \begin{array}{cc} 5 &amp; 8 \end{array} \right]\) i \(\vec p_2 = \left[ \begin{array}{cc} 6 &amp; -1 \end{array} \right]\). Kako se radi o tri točke odnosno kvadratnoj krivulji, \(n=2\), pa je pripadna matrica \(\mathcal{T}\) bila:
\[
\textbf{T} = \left[ \begin{array}{c} 
  \mathcal{T}(0) \\ 
  \mathcal{T}(0.5) \\ 
  \mathcal{T}(1) \\ 
\end{array} \right] = \left[ \begin{array}{ccc} 
  0^2 &amp; 0^1 &amp; 1 \\ 
  0.5^2 &amp; 0.5^1 &amp; 1 \\ 
  1^2 &amp; 1^1 &amp; 1 \\ 
\end{array} \right] = \left[ \begin{array}{ccc} 
  0 &amp; 0 &amp; 1 \\ 
  0.25 &amp; 0.5 &amp; 1 \\ 
  1 &amp; 1 &amp; 1 \\ 
\end{array} \right]
\]
Njezin inverz je:
\[
 (\textbf{T})^{-1} = \left[ \begin{array}{ccc} 
  2 &amp; -4 &amp; 2 \\ 
  -3 &amp; 4 &amp; -1 \\ 
  1 &amp; 0 &amp; 0 \\ 
\end{array} \right]
\]
Umnožak tog inverza i matrice \(\textbf{P}\) daje traženu matricu \(\textbf{K}\):
\[
 \textbf{K} = (\textbf{T})^{-1} \cdot \textbf{P} = \left[ \begin{array}{ccc} 
  2 &amp; -4 &amp; 2 \\ 
  -3 &amp; 4 &amp; -1 \\ 
  1 &amp; 0 &amp; 0 \\ 
\end{array} \right] \cdot \left[ \begin{array}{cc} 1 &amp; 2 \\ 5 &amp; 8\\ 6 &amp; -1 \end{array} \right] = \left[ \begin{array}{ccc} 
  -6 &amp; -30 \\ 
  11 &amp; 27 \\ 
  1 &amp; 2 \\ 
\end{array} \right]
\]
odnosno
\[
 \vec p(t) = \mathcal{T}(t) \cdot \left[ \begin{array}{ccc} 
  -6 &amp; -30 \\ 
  11 &amp; 27 \\ 
  1 &amp; 2 \\ 
\end{array} \right]
\]
čime smo došli do istog rezultata.
</p>

<p>U nastavku možete pogledati kako bi izgledala kubna interpolacijska Bezierova krivulja (stupanj krivulje je 3).</p>

  <div style="width: 800px; height: 500px; position:relative;">
  <canvas id="myCanvas2" width="800" height="500" style="border: 1px solid black;"></canvas>
  </div>
  <script type="text/javascript">
    var bez2 = new drawInterpolationBezier("myCanvas2");
    bez2.addingEnabled = false;
    bez2.buildProc = false;
    bez2.setAllPoints([[38,464],[217,262],[569,243],[760,44]]);
    bez2.paint();
  </script>
  <input type="checkbox" onclick="bez2.curveApprox=this.checked; bez2.paint();"> Aproksimacijska krivulja<br>
  <input type="checkbox" onclick="bez2.controlPolygon=this.checked; bez2.paint();"> Prikaži kontrolni poligon aproksimacijske krivulje<br>
  <input type="checkbox" onclick="bez2.curveInterpol=this.checked; bez2.paint();"> Interpolacijska krivulja<br>
  <input type="checkbox" onclick="bez2.intControlPolygon=this.checked; bez2.paint();"> Prikaži kontrolni poligon za interpolacijsku krivulju<br>

